#!/bin/bash
# Mithat Konar 2009-06-01

# CLI-based screen resolution changer for use with 
# skinny-screenres that writes changes to rscFile in the format specifed
# that script.
# Note: the changes made here are processed at login by skinny-screenres
# if rscFile is processed at session startup.

# Requires xrandr, skinny-screenres

# TODO: Make prompts contants.
# TODO: Input validation.
#
# constants
#
APP_DIR=`dirname "$0"`
cd "$APP_DIR"
APP_DIR=`pwd`

rscFile="$HOME/.skinny-screenresrc"		# writes settings to this file in the format specifed in skinny-screenres

screenCMD=skinny-screenres

#
# functions
#

function showModes()
{
	# needs to grep or sed lines that start with whitespace and prepend [n] 
	#clear
	echo "Available screen resolutions and refresh rates:"
	echo "================================================="
	echo "   Resolution     Refresh rate(s)"
	echo "   ----------     ---------------------"
	xrandr -q | grep ^[[:space:]]
	echo "================================================="
	echo "*indicates mode currently being used"
}

#
# "MAIN"
#

tryAgain=y
while [ "$tryAgain" = "y" ] || [ "$tryAgain" = "Y" ] || [ "$tryAgain" = "yes" ] || [ "$tryAgain" = "YES" ]; do
	clear
	showModes

	# enter size (blank to not change)
	echo -e "\nEnter the Resolution you want to use from the list above [example: 1024x768]"
	read -p "> " screenSize

	if [ -z "$screenSize" ] ; then
		echo
		echo "Nothing was changed."
	else
		echo -e "\rEnter the Refresh rate listed for $screenSize you want to use\n(leave blank to use default): "
		read -p "> " refRate

		if [ -z "$refRate" ] ; then
			echo -e "\rUsing default refresh rate."
			refRate=-1
			echo
		fi

		# Write the new rscFile
		#screenSize=$(( $screenSize - 1 ))
		echo "# Changed by $0 on `date`." > "$rscFile"
		echo "screenSize=$screenSize" >> "$rscFile"
		if [ $refRate -ne -1 ] ; then
			echo "refreshRate=$refRate" >> "$rscFile"
		fi

		echo
		$screenCMD
		isSuccess=$?
		if  [ $isSuccess -ne 0 ] ; then
			echo
			echo "================================================"
			echo " There was a problem with the data you entered."
			echo " The default systems settings will be used."
			echo "================================================"
			xrandr -s 0
		else
			clear
			echo "Settings successfully changed"
			echo
			showModes
		fi
	fi

	echo
	read -p "Do again [y/N]? " tryAgain
done
